
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用SimpleDateFormat注意的地方和在jsp中将字符串转换为日期 / 憋错料</title>

    <meta name="description" content="使用SimpleDateFormat注意的地方和在jsp中将字符串转换为日期 一.使用SimpleDateFormat注意的地方 SimpleDateFormat将字符串转换为日期类型时,转换的格式必须和字符串的格式一样,否则就会报错,比如:将字符串&quot;20150825195057&quot;转化为日期类型,转换格式必须是 &quot;yyyyMMddHHmmss&quot;,如果是其他格式,将会报   java.text.ParseException: Unparseable date: &quot;20150825195057&quot;异常.那如果要将字符串 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">使用SimpleDateFormat注意的地方和在jsp中将字符串转换为日期</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>一、使用SimpleDateFormat注意的地方</strong></p>
<p>　　SimpleDateFormat将字符串转换为日期类型时，转换的格式必须和字符串的格式一样，否则就会报错，比如：将字符串"20150825195057"转化为日期类型，转换格式必须是</p>
<p>"yyyyMMddHHmmss",如果是其他格式，将会报&nbsp;&nbsp; java.text.ParseException: Unparseable date: "20150825195057"异常。那如果要将字符串转换成yyyy-MM-dd HH:mm:ss这种格式，该怎么办呢？　　　　　　解决办法：首先将字符串转换成自己本身的日期格式，然后将转换后的日期再转换成另外一个格式。代码如下</p>
<pre>import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Test {

    public static void main(String[] args) {
        String parseDate = "20150825195057";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        SimpleDateFormat sdf2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            Date date = sdf.parse(parseDate);

            System.out.println(sdf2.format(date));   //输出结果2015-08-25 19:50:57
        } catch (ParseException e) {
            e.printStackTrace();
        }
    }
}</pre>
<p><strong>二、在jsp中将字符串转换成日期类型</strong></p>
<p>这个思路和在java中直接转换时一样的，首先将字符串按照自己原有的格式转换成日期格式，然后再将日期转换成自己想要的格式。</p>
<p>转换的时候应先引进两个头文件</p>
<pre>&lt;%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%&gt;
&lt;%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %&gt;</pre>
<p>然后将日期转换</p>
<pre>&lt;fmt:parseDate value="20150825195057" pattern="yyyyMMddHHmmss" var="date"&gt;&lt;/fmt:parseDate&gt;
&lt;fmt:formatDate value="${date}" pattern="yyyy-MM-dd "/&gt;         //输出2015-08-25</pre>
<p>其中&lt;fmt:parseDate&gt;中的var是给&lt;fmt:formatDate&gt;中的value传值的。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 22:45:24 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>使用SimpleDateFormat注意的地方和在jsp中将字符串转换为日期的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y2jdJ3.html" rel="bookmark">在action中将字符串、对象、list集合保存到值栈中，在jsp页面中获取的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:csdn 封装对象User,属性有id,username,email等1.1:在action中将字符串保存到值栈中   1.1.1 获取值栈对象         ValueStack stack = ActionContext.getContext().getValueStack();   1.1.2 将字符串保存到值栈中         stack.set(&quot;username&quot;,&quot;leo&quot;);1.2:在jsp页面中获取值栈中的字符串   1.2.1 &lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgLrbp0.html" rel="bookmark">JSP页面中格式化日期为指顶格式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有时候在页面中显示直接从数据库获取的日期时候会出现英文的日期格式.比如: 如果想要转为指定格式的日期格式可以用fmt标签. 1.引入fmt库 &lt;%@ taglib uri=&quot;http://java.sun.com/jsp/jstl/fmt&quot; prefix=&quot;fmt&quot;%&gt;  2.使用fmt标签 &lt;fmt:formatDate value=&quot;${danger.findtime }&quot; pattern=&quot;yyyy-MM-dd			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDZABn3.html" rel="bookmark">重温JSP学习笔记--与日期数字格式化有关的jstl标签库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇笔记写的主要是JSTL的core标签库,如果想对一些数字或者日期做一些操作或者在网页上显示指定格式的数字或日期,jstl还提供了另一个fmt标签库,这里简单介绍一下: 第一步,导入标签库: &lt;%@ taglib prefix=&quot;fmt&quot; uri=&quot;http://java.sun.com/jsp/jstl/fmt&quot; %&gt; 格式化时间(在网页面上显示时间): &lt;% Date date=new Date(); pageContext.setAttr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDnq1K3.html" rel="bookmark">jsp截取字符串</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;%@ taglib uri=&quot;http://java.sun.com/jsp/jstl/functions&quot; prefix=&quot;fn&quot;%&gt; &lt;td&gt; ${fn:substring(&quot;xxxx&quot;,0,5)} &lt;/td&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmLvxn4.html" rel="bookmark">jsp中将一个jsp引入另一个jsp指定位置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				&lt;jsp:include page=&quot;badSurveyUpdate.jsp&quot;/&gt; 原文地址:https://www.cnblogs.com/xianz666/p/12052840.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLvJJQ3.html" rel="bookmark">【JSP】JSP检查字符串是否为数字</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				//判断是否是正整数 function IsNum(s) { if(s!=null){ var r,re; re = /\d*/i; //\d表示数字,*表示匹配多个数字 r = s.match(re); return (r==s)?true:false; } return false; } //判断是否为数字 function IsNum(s) { if (s!=null &amp;&amp; s!=&quot;&quot;) { return !isNaN(s); //不为数字返回TRUE } ret			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0byOVwM.html" rel="bookmark">Java 日期与字符串的转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				import java.text.ParseException; import java.text.SimpleDateFormat; import java.util.Date; public class ConvertUtil { /** * 字符串转换为日期 * @param string 字符串 * @return 日期 * @throws ParseException */ public static Date stringToDate(String string) throws Pa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aGdBE4.html" rel="bookmark">Jsp之神笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JSP笔记 Tomcatserver port: port就是指的某一个程序网络入口,Tomcat的初始化port为:8080: port的个数:256*256=65536个: 一般常见协议的缺省port为: http                    80 smtp                  25 pop3                   110 ftp                       23 https                  443 port占用查看命令			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QdkKl3.html" rel="bookmark">java日期格式大全 format SimpleDateFormat</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/**    * 字符串转换为java.util.Date&lt;br&gt;    * 支持格式为 yyyy.MM.dd G 'at' hh:mm:ss z 如 '2002-1-1 AD at 22:10:59 PSD'&lt;br&gt;    * yy/MM/dd HH:mm:ss 如 '2002/1/1 17:55:00'&lt;br&gt;    * yy/MM/dd HH:mm:ss pm 如 '2002/1/1 17:55:00 pm'&lt;br&gt;    * yy-MM-dd HH:			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQ5NQ3.html" rel="bookmark" class="title">养成良好的写代码习惯</a>
					<div>
						看了上一节hello world一篇,相信你对C语言语法结构有了一定感触,其实基本上每个C语言程序代码都是那样的声明,那样的框架,而要填充的内容就是框架内的内容.会了hello world,其他的也就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5PK90.html" rel="bookmark" class="title">Struts2多文件的上传</a>
					<div>
						Struts2Test.java源代码: package com.test; import java.io.File; import java.io.FileInputStream; import j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49ZjrgM.html" rel="bookmark" class="title">Java实现简单网页抓取</a>
					<div>
						需求说明:使用Java抓取网页信息,并以字符串的形式返回. 使用Java代码实现: package net.ibuluo.spider.util; import java.io.IOException ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MG82vZ0.html" rel="bookmark" class="title">弹性碰撞</a>
					<div>
						只有一个球时,这就是单纯的物理问题. 多个球时,所有的球都是一样的,两个球相撞后互相交换速度,可以视为直接互相穿过继续运动. 由于在碰撞时球的顺序是不会改变的,先落下的球始终在下面. 所以将计算出的每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wWpl0.html" rel="bookmark" class="title">HDU&mdash;&mdash;2063 过山车</a>
					<div>
						过山车 Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoxNOb0.html" rel="bookmark" class="title">读智能时代的所思所想</a>
					<div>
						这是最好的时代,也是最坏的时代 智能时代下最初受益的都是发展它,使用它的人.而远离他决绝接受他的人,在很长的时间都将是迷茫的一代. 智能时代通过当下大数据盛行以及数据成为下一代技术革命和社会变革的核心 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRVAr3.html" rel="bookmark" class="title">angularJs的作用域和依赖注入</a>
					<div>
						一.angularJs的作用域 &lt;!DOCTYPE HTML&gt; &lt;html ng-app&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38byPWM.html" rel="bookmark" class="title">构建之法第八、九章学习</a>
					<div>
						第八章:需求分析 这一章主要讲述了软件需求的类型.利益相关者.获取用户需求的常用方法和步骤.竞争性需求分析的框架NABCD.四象限方法.项目计划和估计的技术. 确认软件需求有以下步骤:1.获取和引导需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZwV90.html" rel="bookmark" class="title">【转】Linux下XenServer管理工具安装</a>
					<div>
						转载文章 - Linux下XenServer管理工具安装 Xen-Server 6.5 虚拟机安装Linux系统 vmware安装ubuntu12.04嵌套安装xen server(实现嵌套虚拟化)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWVkJB4.html" rel="bookmark" class="title">算法竞赛入门经典 第二版 1-3答案</a>
					<div>
						挂完月考又滚回来玩OI了,对于书中前几章例题,没有答案还是比较慌,找了许久也没用什么完全符合的.其中不错的有一篇写下来看看 http://wenku.baidu.com/link?url=Ofu2LH ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Onv6g0.html" rel="bookmark" class="title">软件测试对比软件开发，你适合哪款？</a>
					<div>
						通常二选一,最残酷.选择一种必然要放弃另一种.但是对于测试和开发,你中有我,我中有你才是最高境界.反正我是测试员,到底哪款适合你呢? 一个测试员的&quot;宽度&quot; 掌握软件测试的理论知识: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OylY8M.html" rel="bookmark" class="title">Servlet知识</a>
					<div>
						1.Servlet概述 2.编写Servlet的开发步骤a.建立标准的JavaWeb应用目录FirstAppWEB-INFclasseslibweb.xmlb.编写一个类,实现javax.servle ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWrZgG4.html" rel="bookmark" class="title">&lbrack;转&rsqb;Queue基本操作</a>
					<div>
						(java版) import java.util.LinkedList; //单向队列 public class Queue { public Queue() { } private LinkedLi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a67pk3.html" rel="bookmark" class="title">android 的四种枚举</a>
					<div>
						1.Context.MODE_PRIVATE:为默认操作模式,代表该文件是私有数据,只能被应用本身访问,在该模式下,写入的内容会覆盖原文件的内容,如果想把新写入的内容追加到原文件中.可以使用Conte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgloo3.html" rel="bookmark" class="title">css空格和去浮动的应用</a>
					<div>
						今天做了项目用到css,请教前端解决,第一个是记得css空格之间的关系是隶属关系,但是在元素中却是并列关系,如&lt;div class=&quot;right_side_item_moban gra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RjKrP0.html" rel="bookmark" class="title">移动互联网时代：如何让姑娘在一分钟内爱上你？</a>
					<div>
						上篇&lt;移动互联网时代:要让姑娘在一分钟爱上你&gt;实际上只是提出了本人独创的具有自主知识产权的移动互联网的相亲思维,并没有真正地去阐述如何让姑娘在一分钟内爱上你?现实生活中,估计也没有那么简单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3raVjX0.html" rel="bookmark" class="title">Azkaban使用示例</a>
					<div>
						1.Web端管理工作流 Azkaban提供了易操作的Web管理界面,具体操作可参考:http://azkaban.github.io/azkaban/docs/2.5/#ajax-api 值得注意的是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoXygP0.html" rel="bookmark" class="title">C语言中静态库和动态库笔记</a>
					<div>
						库 库,故名思议,是存放东西的地方,其中存放的东西可以被多个人公用. 程序中借用库的概念,描述将代码进行抽取,这种代码被大多数程序使用, 其过程具有一定的模块化.封装.抽象的特征. 按照库的使用方式, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d7E7nM.html" rel="bookmark" class="title">Who&amp;&num;39&semi;s in the Middle&lbrack;HDU1157&rsqb;</a>
					<div>
						Who's in the Middle Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Othe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A2rLzM.html" rel="bookmark" class="title">PicPopupWindow的使用</a>
					<div>
						Github地址https://github.com/lujianfeiccie/android_picpopup_window 效果图1: 效果图2:					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
